#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "Wacom.h"
#ifndef c_ALPHA
#include "Greek.h"
#endif

#define NUM_HASHLISTS	5
#define NUM_FEATURES		9

#define TRUE 1
#define FALSE 0

#ifndef NIL
#define NIL				0L
#define ABS(x)			((x)>0?(x):(-(x)))
#define MAX(a,b)		((a)>(b)?(a):(b))
#define MIN(a,b)		((a)<(b)?(a):(b))
#endif

#define MAX_POINTS	200
#define MAX_N 			50
#define IN_PROXIMITY (!Wacom || TRecord->flags & PROXIMITY)

typedef void *GenericT;

typedef struct {
	unsigned long index;
	short code;
	} AVPair;

typedef struct {
	short		num_items;
	AVPair	items[];
	} *AVList;

typedef struct {
	short		num_items;
	GenericT	items[];
	} *List;

typedef struct GesturePattern {
	short		code;
	List		strokes;
	} GesturePattern;

typedef struct StrokePattern {
	char	is_dot;
	List	s[NUM_FEATURES];
	} StrokePattern;

typedef struct StrokeData {
	Point		Ink[MAX_POINTS];
	Point 	P[MAX_N];
	short 	Ink_Num,N,T[MAX_N],U[MAX_N];
	short		IsDot;
	unsigned long S[NUM_FEATURES];
	double	Aspect_Ratio;
	long		Xmax,Xmin,Ymax,Ymin,Height,Width;
	long		XmaxT,XminT,YmaxT,YminT,HeightT,WidthT;
	long		start_time,end_time;
	List		matches;
	} StrokeData,*StrokePtr;

typedef struct GestureData {
	List		strokes;
	long		Xmax,Xmin,Ymax,Ymin;
	} GestureData,*GesturePtr;


extern short Wacom;
extern TABLETRECORD *TRecord;
extern long ScreenYSize,TabYSize,TabYMin,ScreenXSize,TabXSize,TabXMin;
#define TAB_TO_SCREEN_X(x) (((long)x - TabXMin) * ScreenXSize / TabXSize)
#define TAB_TO_SCREEN_Y(y) (((long)y - TabYMin) * ScreenYSize / TabYSize)
#define SCREEN_TO_TAB_Y(y) (((long)y * TabYSize / ScreenYSize) + TabYMin)

void	Append(List *theList,long item);
void	ReadPatterns(void);
void	SavePatterns(void);
short	Recognize(void);
void	RecognizeStroke(short whichStroke);
void	RecognizerInit(void);
short TryCollectGesture(Point where,long when);
short	CollectStroke(Point where,StrokePtr theStroke);
void	ComputeBBox(void);
short	ATAN2(short,short);
short IsInList(List list,long n);
void DoTrainingDialog(void);
void DoFastTrainerDialog(void);
void AppendAVPair(AVList *theList,AVPair item);
void MakeSearchTables(void);
void SearchAndAddMatches(short*,short*,short*,AVList theList,unsigned long n,short w);
void SetupMapping(void);
void	Simplify(StrokePtr theStroke,Point *Ink,short N);
void	Analyze(StrokePtr);
void Set_Current_Pattern(void);
short NumSymbols(void);
short Code(short n);
void DrawCode(short n);
short FindCode(short code);
void AddNewPattern(void);
void ExtendRange(void);
void DisposePatterns(void);
void FreeStrokes(void);
void ConvertLongToString(char *s,unsigned long n,short bits,char *name);
void ConvertStringToLong(char *s,unsigned long *np,short bits);
void ComputeT(StrokePtr theStroke);

extern AVList HashList[];
extern List		patterns,Strokes;
extern short Current_Pattern,Learn_Code;
extern StrokePtr The_Stroke;
extern Rect BBox;
extern short Dont_Use_Table,Training,PauseIsMouse,TRAINING_TIME_OUT,min_weight,
				RecognizeWords;


#ifndef _H_Global
typedef		void (*VoidFunc)(...);			/* Ptr to a function returning void	*/
#endif
typedef struct { unsigned char *name; short code; } NamedCode;
extern NamedCode Commands[];
extern short Num_Commands;

extern short VoteWeight[];
extern char Bits[];
extern VoidFunc HashFunctions[];
extern char *Names[];

